from typing import Any
from python.libdaw.time import Timestamp

class Beat:
    def __new__(cls: type, value: float): ...
    def __lt__(self, other: Beat) -> bool: ...
    def __le__(self, other: Beat) -> bool: ...
    def __eq__(self, other: Any) -> bool: ...
    def __ne__(self, other: Any) -> bool: ...
    def __gt__(self, other: Beat) -> bool: ...
    def __ge__(self, other: Beat) -> bool: ...
    @property
    def value(self) -> float: ...

class BeatsPerMinute:
    def __new__(cls: type, value: float): ...
    def __lt__(self, other: BeatsPerMinute) -> bool: ...
    def __le__(self, other: BeatsPerMinute) -> bool: ...
    def __eq__(self, other: Any) -> bool: ...
    def __ne__(self, other: Any) -> bool: ...
    def __gt__(self, other: BeatsPerMinute) -> bool: ...
    def __ge__(self, other: BeatsPerMinute) -> bool: ...
    @property
    def value(self) -> float: ...

class TempoInstruction:
    def __new__(cls: type, beat: Beat, tempo: BeatsPerMinute): ...
    def __lt__(self, other: TempoInstruction) -> bool: ...
    def __le__(self, other: TempoInstruction) -> bool: ...
    def __eq__(self, other: Any) -> bool: ...
    def __ne__(self, other: Any) -> bool: ...
    def __gt__(self, other: TempoInstruction) -> bool: ...
    def __ge__(self, other: TempoInstruction) -> bool: ...

    @property
    def beat(self) -> Beat: ...

    @property
    def tempo(self) -> BeatsPerMinute: ...

class Metronome:
    def __new__(cls: type): ...
    def add_tempo_instruction(self, instruction: TempoInstruction) -> None: ...
    def beat_to_time(self) -> Timestamp: ...
